/************************************************************************\
*                                                                        *
* CookMail 2 - Binary Tree                                               *
* (c) Copyright Heng Yuan 1997                                           *
* All Rights Reserved.                                                   *
*                                                                        *
* Do NOT distribute this program in any modified format.                 *
*                                                                        *
* Description:                                                           *
*      A Form Handling CGI script for Unix & Windows NT                  *
*                                                                        *
\************************************************************************/

#ifndef __BTREE_H__
#define __BTREE_H__

typedef struct btree_tag
  {
    struct btree_tag *prev;
    char *data;
    char *value;
    struct btree_tag *next;

    /* boy, this is a trouble
       to make ETC work, sequencially addtree */
    struct btree_tag *linearnext;
  } btree;

/* addtree will add the data and value to the tree.  If there is
   a data having the same name, it would be replaced with new data */
btree *addtree (btree *tree, char *data, char *value, btree *linear);

/* getdata returns value.  If this value is NULL, it could mean either
   the tree data is not found, or the value for this data is null */
char *getdata (btree *tree, char *data);

/* get datavalue from a given node */
#define getnodedata(tree) (tree->value)

/* searchtree searchs and put result in tree */
int searchtree (btree **tree, const char *data);

/* intree find out whether data is present in tree */
int intree (btree *tree, char *data);

/* trashtree destroy the tree */
void trashtree (btree *tree);

#endif  /* __BTREE_H__ */
