/************************************************************************\
*                                                                        *
* HTML CGI Library - I/O Routines                                        *
* (c) Copyright Heng Yuan 1996                                           *
* All Rights Reserved.                                                   *
*                                                                        *
* Do NOT distribute this program in any modified format.                 *
*                                                                        *
* Description:                                                           *
*      A Form Handling CGI script for Unix                               *
*                                                                        *
\************************************************************************/

#ifndef __HTML_H__
#define __HTML_H__

#include "btree.h"
#include "html_env.h"

extern int STARTCGIENV;

/* must for all cgi scripts */
void startcgi ( void );          /* find starting location for CGI env */
void showoutput (CONTENT_TYPES);  /* start cgi out put */
void showhtml (const char *);     /* display another HTML doc instead */

/* the stdout write checking printf */
int putsf (const char *, ...);

/* get cgi post, get, or query method string */
int getmethod ( void );

/* get form input and environmental values */
char *getformdata (const char *);

/* add global env variable */
btree *addtreeglobal (char *data, char *datavalue);

/* check if a string is empty */
int isemptyenv (const char *str);

extern btree *linearstart;

#endif  /* __HTML_H__ */
