/************************************************************************\
*                                                                        *
* HTML CGI Library - Environment Macro                                   *
* (c) Copyright Heng Yuan 1996                                           *
* All Rights Reserved.                                                   *
*                                                                        *
* Do NOT distribute this program in any modified format.                 *
*                                                                        *
* Description:                                                           *
*      A Form Handling CGI script for Unix                               *
*                                                                        *
\************************************************************************/

#ifndef __HTML_ENV_H__
#define __HTML_ENV_H__

#include <stdlib.h>

/* the environmental array */
extern char **environ;

/* environment names */

extern char auth_type[];

extern char content_length[];
extern char content_type[];

extern char date_gmt[];
extern char date_local[];

extern char document_name[];
extern char document_uri[];

extern char gateway_interface[];

extern char http_accept[];
extern char http_pragma[];
extern char http_referer[];
extern char http_user_agent[];

extern char last_modified[];

extern char mailcheck[];

extern char dup_optind[];  /* avoid complicting types for optind */

extern char path[];
extern char path_translated[];

extern char query_string[];

extern char remote_addr[];
extern char remote_host[];
extern char remote_ident[];
extern char remote_user[];

extern char request_method[];

extern char script_name[];

extern char server_name[];
extern char server_port[];
extern char server_protocol[];
extern char server_software[];

/* get environment names */

#define AUTH_TYPE getenv (auth_type)

#define CONTENT_TYPE getenv (content_type)
#define CONTENT_LENGTH getenv (content_length)

#define DATE_GMT getenv (date_gmt)
#define DATE_LOCAL getenv (date_local)

#define DOCUMENT_NAME getenv (document_name)
#define DOCUMENT_URI getenv (document_uri)

#define GATEWAY_INTERFACE getenv (gateway_interface)

#define HTTP_ACCEPT getenv (http_accept)
#define HTTP_PRAGMA getenv (http_pragma)
#define HTTP_REFERER getenv (http_referer)
#define HTTP_USER_AGENT getenv (http_user_agent)

#define LAST_MODIFIED getenv (last_modified)

#define MAILCHECK getenv (mailcheck)

#define OPTIND getenv (dup_optind)

#define PATH getenv (path)
#define PATH_TRANSLATED getenv (path_translated)

#define QUERY_STRING getenv (query_string)

#define REMOTE_ADDR getenv (remote_addr)
#define REMOTE_HOST getenv (remote_host)
#define REMOTE_IDENT getenv (remote_ident)
#define REMOTE_USER getenv (remote_user)

#define REQUEST_METHOD getenv (request_method)

#define SCRIPT_NAME getenv (script_name)

#define SERVER_NAME getenv (server_name)
#define SERVER_PORT getenv (server_port)
#define SERVER_PROTOCOL getenv (server_protocol)
#define SERVER_SOFTWARE getenv (server_software)

/* Content-type:  */
extern char *content_types[];
typedef enum
  {
    PLAIN,
    HTML,
    GIF,
    JPEG,
    XBITMAP,
    XPIXELMAP
  } CONTENT_TYPES;

#endif  /* __HTML_ENV_H__ */
