#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "mime.h"

static char mime_header[] = "\
Mime-Version: 1.0\n\
Content-Transfer-Encoding: base64\n\
Content-Type: text/plain\n\n";

/* this function is for single part messages, assume
   all the necessary headers are already included. */
char *mime_encode (char *message, int size)
{
  char *ptr, *ptr2 = message, *buffer, *headerend;
  if (message == NULL || size <= 0)
    return NULL;
  do
    {
      ptr = ptr2;
      ptr2 = strchr (ptr, '\n');
      if (ptr2 == NULL)
	return NULL;
      if (*ptr2 == '\r')
	ptr2++;
      ptr2++;
    }
  while (*ptr2 != '\n');

  headerend = ptr2;
  ptr2++;
  if (*ptr2 == '\r')
    ptr2++;
  ptr = mime_encode_base64 (ptr2, size - (ptr2 - message));               
  buffer = (char *)malloc (headerend - message +
			   sizeof (mime_header) + strlen (ptr));
  if (buffer == NULL)
    return NULL;
  sprintf (buffer, "%.*s%s%s",
	  (int)(headerend - message), message,
	  mime_header, ptr);
  free (ptr);
  return buffer;
}
